﻿-- Author      : Razielexx-Quel'Thalas
-- Create Date : 03/25/2016
local loop = 10;
local total = 0
local ft;
local scanning = false;

function FrameSatchelFinder_OnLoad()
	ValidateForm();
	DEFAULT_CHAT_FRAME:AddMessage("SatchelFinder: Loaded!");
end

function CheckLKF()
	lblStatus:SetText("Searching...");
	local dungeonID = LFDQueueFrame.type
	if type(dungeonID) == "number" then
		for i = 1, LFG_ROLE_NUM_SHORTAGE_TYPES do
		local eligible, forTank, forHeal, forDps, itemCount, money, xp = GetLFGRoleShortageRewards(dungeonID, i)	
			if eligible == true and itemCount ~= 0 then	
				if forTank == true and chkTank:GetChecked() == true then Ready("Tank", dungeonID) end
				if forHeal == true and chkHeal:GetChecked() == true then Ready("Heal", dungeonID) end
				if forDps == true and chkDps:GetChecked() == true then Ready("Dps", dungeonID) end
			end
		end
	end
end

function btnSearch_OnClick()
	scanning = true;
	PlaySoundFile("Sound\\Interface\\LFG_Rewards.ogg");
	if not ft then
	ft = CreateFrame("Frame")
		ft:SetScript("OnUpdate", SetTimer)
	end
	DEFAULT_CHAT_FRAME:AddMessage("SatchelFinder: Searching...");
	lblStatus:SetText("Searching...");
	DisableChecks();
	DisableBtns();
end

function SetTimer(self,elapsed)
    total = total + elapsed
    if total >= loop and scanning == true then
		CheckLKF();
        total = 0
    end
end

function btnStop_OnClick()
	scanning = false;
	DEFAULT_CHAT_FRAME:AddMessage("SatchelFinder: Stoped...");
	lblStatus:SetText("");
	PlaySoundFile("Sound\\Interface\\LFG_Denied.ogg");
	EnabledChecks();
	EnabledBtns();
end

function Ready(Type, dungeonID)
   PlaySound("ReadyCheck");
   scanning = false;
   EnabledChecks();
   EnabledBtns();
   DEFAULT_CHAT_FRAME:AddMessage("SatchelFinder: Satchel find for " .. Type .. "!");
   lblStatus:SetText("Find for " .. Type .. "!");
end

function ValidateForm()
   if chkTank:GetChecked() == false and chkHeal:GetChecked() == false and chkDps:GetChecked() == false then
		DisableBtns();
		btnStop:Disable();
	else
		EnabledBtns();
   end
end

function EnabledChecks()
   chkTank:Enable();
   chkHeal:Enable();
   chkDps:Enable();
end

function DisableChecks()
   chkTank:Disable() ;
   chkHeal:Disable();
   chkDps:Disable() ;
end

function EnabledBtns()
   btnSearch:Enable();
   btnStop:Disable();
end

function DisableBtns()
   btnSearch:Disable();
   btnStop:Enable();
end

